Index: branches/terrain/src/lib/graphics/importer/md3/md3_animation_cfg.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/md3/md3_animation_cfg.cc	(revision 9413)
+++ branches/terrain/src/lib/graphics/importer/md3/md3_animation_cfg.cc	(revision 9414)
@@ -173,5 +173,5 @@
         }
 	}
-    }
+    }*/
       */
   }
Index: branches/terrain/src/lib/graphics/importer/terrain/buffer_broker.h
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/buffer_broker.h	(revision 9414)
+++ branches/terrain/src/lib/graphics/importer/terrain/buffer_broker.h	(revision 9414)
@@ -0,0 +1,136 @@
+/*
+        orxonox - the future of 3D-vertical-scrollers
+
+        Copyright (C) 2006 orx
+
+        This program is free software; you can redistribute it and/or modify
+        it under the terms of the GNU General Public License as published by
+        the Free Software Foundation; either version 2, or (at your option)
+        any later version.
+
+        ### File Specific:
+        main programmer: Marco Biasini
+
+ */
+
+#ifndef _BUFFERBROKER_H
+#define _BUFFERBROKER_H
+
+#include "glincl.h"
+#include "debug.h"
+#include "types.h"
+/**
+ * @brief       Manages the streaming of the vertex buffer objects for the terrain page.
+ */
+
+struct BufferPair {
+        BufferPair( int _i, int _v ) { indexName = _i; vertexName = _v; next = NULL; }
+        BufferPair() { indexName = vertexName = 0; next = NULL; }
+        GLuint                  indexName;
+        GLuint                  vertexName;
+        BufferPair              *next;
+};
+
+typedef BufferPair *pBufferPair;
+
+class BufferBroker {
+        public:
+
+                BufferBroker( int _num, int _vbSize, int _ibSize )
+                {
+                        capacity = _num;
+                        freeIndexBuffers = new GLuint[capacity];
+                        freeVertexBuffers =     new GLuint[capacity];
+                        lastAcquired = 0;
+                        vbSize = _vbSize; ibSize = _ibSize;
+                        glGenBuffersARB( capacity, freeIndexBuffers );
+                        glGenBuffersARB( capacity, freeVertexBuffers );
+                        for ( int i = 0; i < capacity; ++i ) {
+                                glBindBufferARB( GL_ARRAY_BUFFER_ARB, freeVertexBuffers[i] );
+                                glBufferDataARB( GL_ARRAY_BUFFER_ARB, vbSize,
+                                        NULL, GL_DYNAMIC_DRAW_ARB );
+                                glBindBufferARB( GL_ELEMENT_ARRAY_BUFFER_ARB, freeIndexBuffers[i] );
+                                glBufferDataARB( GL_ELEMENT_ARRAY_BUFFER_ARB, ibSize,
+                                        NULL, GL_DYNAMIC_DRAW_ARB );
+                        }
+                        head = tail = NULL;
+                }
+                ~BufferBroker()
+                {
+                        pBufferPair bp = head;
+                        while ( bp ) {
+                                pBufferPair tmp = bp->next;
+                                release( bp->vertexName, bp->indexName );
+                                bp = tmp;
+                        }
+                        glDeleteBuffersARB( capacity, freeVertexBuffers );
+                        glDeleteBuffersARB( capacity, freeIndexBuffers );
+                        SAVE_DELETE_ARRAY( freeIndexBuffers );
+                        SAVE_DELETE_ARRAY( freeVertexBuffers );
+                }
+                inline int getIBSize() { return ibSize; }
+                inline int getVBSize() { return vbSize; }
+                inline void acquire( GLuint &_vbName, GLuint &_ibName );
+
+                inline void release( const GLuint &_vbName, const GLuint &_ibName );
+        protected:
+
+                int                                             capacity;
+
+                int                                             vbSize,
+                                                                ibSize;
+                int                                             lastAcquired;
+
+                GLuint                                  *freeIndexBuffers,
+                                                                *freeVertexBuffers;
+
+                BufferPair                              *head, *tail;
+};
+
+inline void BufferBroker::release( const GLuint &_vbName, const GLuint &_ibName )
+{
+        pBufferPair bp = head, prev = NULL;
+        bool removed = false;
+        while ( bp ) {
+
+                if ( bp->indexName == _ibName && bp->vertexName == _vbName ) {
+                        if ( prev ) {
+                                prev->next = bp->next;
+                        }
+                        else {
+                                head = bp->next;
+                        }
+                        if ( bp->next == NULL )
+                                tail = prev;
+                        int index = capacity-lastAcquired;
+                        lastAcquired--;
+                        freeIndexBuffers[index] = bp->indexName;
+                        freeVertexBuffers[index] = bp->vertexName;
+                        delete bp;
+                        removed = true;
+                        break;
+                }
+                prev = bp;
+                bp = bp->next;
+        }
+        assert( removed );
+}
+
+inline void BufferBroker::acquire( GLuint &_vbName, GLuint &_ibName )
+{
+        assert( capacity > lastAcquired );
+        int index = capacity-lastAcquired-1;
+        _vbName = freeVertexBuffers[index]; _ibName = freeIndexBuffers[index];
+        lastAcquired++;
+        if ( tail ) {
+                tail->next = new BufferPair( _ibName, _vbName );
+                tail = tail->next;
+        }
+        else {
+                tail = head = new BufferPair( _ibName, _vbName );
+        }
+}
+
+typedef BufferBroker *pBufferBroker;
+
+#endif
Index: branches/terrain/src/lib/graphics/importer/terrain/frustum.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/frustum.cc	(revision 9414)
+++ branches/terrain/src/lib/graphics/importer/terrain/frustum.cc	(revision 9414)
@@ -0,0 +1,17 @@
+/*
+	orxonox - the future of 3D-vertical-scrollers
+ 
+	Copyright (C) 2006 orx
+ 
+	This program is free software; you can redistribute it and/or modify
+	it under the terms of the GNU General Public License as published by
+	the Free Software Foundation; either version 2, or (at your option)
+	any later version.
+ 
+	### File Specific:
+	main programmer: Marco Biasini
+ 
+ */
+
+#include "frustum.h"
+
Index: branches/terrain/src/lib/graphics/importer/terrain/frustum.h
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/frustum.h	(revision 9414)
+++ branches/terrain/src/lib/graphics/importer/terrain/frustum.h	(revision 9414)
@@ -0,0 +1,140 @@
+/*
+	orxonox - the future of 3D-vertical-scrollers
+ 
+	Copyright (C) 2006 orx
+ 
+	This program is free software; you can redistribute it and/or modify
+	it under the terms of the GNU General Public License as published by
+	the Free Software Foundation; either version 2, or (at your option)
+	any later version.
+ 
+	### File Specific:
+	main programmer: Marco Biasini
+ 
+ */
+#ifndef _FRUSTUM_H
+#define _FRUSTUM_H
+#include "plane.h"
+#include "vector.h"
+#include "types.h"
+#include "glincl.h"
+#include <stdio.h>
+
+
+#define MAX_CLIP_DISTANCE 800.0f
+#define m( _col, _row )  _m[_row*4+_col]
+
+#define CHECK_GL_ERROR( _d ) do { \
+	GLenum __err = glGetError(); \
+	if ( __err != GL_NO_ERROR ) \
+		printf( "check%s: %s\n", _d, (char*)gluErrorString( __err ) );\
+	}\
+	while ( 0 )
+	
+/** 
+ * Code borrowed from Lighthouse 3D. Its a very good tutorial on culling.
+ */
+class Frustum;
+typedef Frustum *pFrustum;
+class Frustum {
+
+	public:
+		
+		enum { NEAR = 0 , FAR = 1, TOP = 2, BOTTOM = 3, LEFT = 4, RIGHT = 5 };
+		enum { OUTSIDE, INTERSECT, INSIDE };		
+		
+		Frustum()
+		{
+			planes = new Plane[6];
+		}
+		~Frustum()
+		{
+			if ( planes )
+				delete[] planes;
+		}
+		/**
+		 * Extracts the frustum planes from the GL_PROJECTION and GL_MODELVIEW
+		 * matrices...
+		 */
+		inline void extractPlanes()
+		{
+			float proj[16], view[16], combined[16];
+			glGetFloatv( GL_MODELVIEW_MATRIX, view );
+			glGetFloatv( GL_PROJECTION_MATRIX, proj );
+			multMat( combined, view, proj );
+			setFrustum( combined );
+		}
+		
+		inline int boxInFrustum( const ABox& _box )
+		{
+			int result = INSIDE;
+			//for each plane do ...
+			for( int i = 0; i < 6; ++i ) {
+
+				// is the positive vertex outside?
+				if ( planes[i].distancePoint( _box.vertexP( planes[i].n ) ) < 0 )
+					return OUTSIDE;
+				// is the negative vertex outside?	
+				else if ( planes[i].distancePoint( _box.vertexN( planes[i].n ) ) < 0 )
+					result = INTERSECT;
+			}
+			return result;
+		}
+		
+		inline int pointInFrustum( const Vector& _point)
+		{
+			int result = INSIDE;
+			for(int i=0; i < 6; i++) {
+				if (planes[i].distancePoint( _point ) < 0)
+					return OUTSIDE;
+			}
+			return result;		
+		}
+		
+		inline Plane getPlane( int _plane ) { return planes[_plane]; }
+		
+		inline void setFrustum( float *_m )
+		{
+			planes[NEAR] =  Plane( Vector( 
+				m(2,0) + m(3,0), 
+				m(2,1) + m(3,1), 
+				m(2,2) + m(3,2) ), 
+				m(2,3) + m(3,3) );
+				
+			planes[FAR] = Plane( Vector( 
+				-m(2,0) + m(3,0),
+				-m(2,1) + m(3,1),
+				-m(2,2) + m(3,2) ),
+				-m(2,3) + m(3,3) );
+									
+			planes[BOTTOM] = Plane( Vector( 
+				m(1,0) + m(3,0), 
+				m(1,1) + m(3,1), 
+				m(1,2) + m(3,2) ), 
+				m(1,3) + m(3,3) );
+			planes[TOP] = Plane( Vector(  
+				-m(1,0) + m(3,0),
+				-m(1,1) + m(3,1),
+				-m(1,2) + m(3,2) ),
+				-m(1,3) + m(3,3) );
+			planes[LEFT] = Plane( Vector(  
+				m(0,0) + m(3,0),
+				m(0,1) + m(3,1),
+				m(0,2) + m(3,2) ),
+				m(0,3) + m(3,3) );
+			planes[RIGHT] =  Plane( Vector( 
+				-m(0,0) + m(3,0),
+				-m(0,1) + m(3,1),
+				-m(0,2) + m(3,2) ),
+				-m(0,3) + m(3,3) );
+							
+			if ( planes[NEAR].k +planes[FAR].k  > MAX_CLIP_DISTANCE ) {
+				planes[FAR].k = -planes[NEAR].k+MAX_CLIP_DISTANCE;
+			}
+		}
+		
+	protected:
+		Plane		*planes;
+};
+
+#endif
Index: branches/terrain/src/lib/graphics/importer/terrain/terrain.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/terrain.cc	(revision 9414)
+++ branches/terrain/src/lib/graphics/importer/terrain/terrain.cc	(revision 9414)
@@ -0,0 +1,473 @@
+
+#include "terrain.h"
+#include "terrain_page.h"
+#include "glincl.h"
+#include "util/loading/resource_manager.h"
+#include "debug.h"
+#include <math.h>
+#ifdef HAVE_SDL_SDL_IMAGE_H
+#include <SDL/SDL_image.h>
+#else
+#include <SDL_image.h>
+#endif
+
+bool validateSize( int _s ) {
+	_s-=1;
+	int s = 16;
+	while ( s <= _s ) {
+		if (s == _s )
+			return true;
+		s*=2;
+	}
+	return false;
+}
+void Terrain::build()
+{
+	ResourceManager *MANAGER = ResourceManager::getInstance();
+	std::string full = MANAGER->getFullName( heightmapSource );
+	SDL_Surface *tmpData = IMG_Load( full.c_str() );
+ 	if ( !tmpData ) {
+		PRINT(0)( "I' sorry, I can't load %s\n", full.c_str() );
+		return;
+	}		
+	if ( !validateSize( tmpData->h ) || !validateSize( tmpData->w ) ) {
+		PRINT(0)( "The size of the elevation map must be 2^n+1x2^m+1. and at least 17x17" );
+		return;
+	}
+	if ( tmpData->format->BytesPerPixel != 1 ) {
+		PRINT(0)( "The elevetation map must be an 8bit image not %d", 
+			tmpData->format->BytesPerPixel*8 );
+		return;
+	}
+	PRINTF(2)( "Loaded the elevation map\n" );
+	heightfield.height = tmpData->h;
+	heightfield.width = tmpData->w;
+	heightfield.pitch = tmpData->pitch;
+	int dataSize = heightfield.pitch*heightfield.height;
+	heightfield.data = new Uint8[dataSize];
+	memcpy( heightfield.data, tmpData->pixels, sizeof(Uint8)*dataSize );
+	SDL_FreeSurface( tmpData );
+	pagesX = (heightfield.width/(pageSize-1) );
+	pagesZ = (heightfield.height/(pageSize-1) );
+	
+	
+	pages = new pTerrainPage[pagesX*pagesZ];	
+	for ( int x = 0; x < pagesX; ++x )
+		for ( int z = 0; z < pagesZ; ++z )
+			pages[z*pagesX+x] = createPage( x, z );
+	//Inform each page about its neighbors.
+	for ( int x = 0; x < pagesX; ++x )
+		for ( int z = 0; z < pagesZ; ++z )
+			pages[z*pagesX+x]->setNeighbors(
+				x > 0 			? getPage( x-1, z+0 ) : NULL,
+				x < pagesX-1	? getPage( x+1, z+0 ) : NULL, 
+				z < pagesZ-1	? getPage( x+0, z+1 ) : NULL,
+				z > 0 			? getPage( x+0, z-1 ) : NULL );
+	
+	root = createQuadTree( 0, 0, pagesX, pagesZ );
+	
+	for ( unsigned int i = 0; i < layers.size(); ++i ) {
+		determineLayerVisibility( i );
+	}	
+	activePages = NULL;
+}
+
+pTerrainQuad Terrain::createQuadTree( int _x0, int _z0, int _x1, int _z1, int _depth )
+{
+	int _x01 = (_x1+_x0)/2; int _z01 = (_z1+_z0)/2;
+	pTerrainQuad node;
+	if ( _x1-_x0 == 1 ) {
+		node = getPage( _x0, _z0 );
+		node->setChildren( NULL, NULL, NULL, NULL );
+	}
+	else {	
+		node = new TerrainQuad( this, _x0, _z0, _x1, _z1 );
+		node->setChildren( 
+			createQuadTree( _x0, _z0, _x01, _z01, _depth+1 ),
+			createQuadTree( _x01, _z0, _x1, _z01, _depth+1 ), 
+			createQuadTree( _x0, _z01, _x01, _z1, _depth+1 ), 
+			createQuadTree( _x01, _z01, _x1, _z1, _depth+1 ) );
+	}
+	node->calculateBounds();
+	return node;
+}
+
+pTerrainPage Terrain::createPage( int _xOffset, int _zOffset ) const
+{
+	pTerrainPage newPage = new TerrainPage( const_cast<Terrain*>( this ), _xOffset, _zOffset );
+	newPage->setScale( scale );	
+	newPage->setPosition( Vector( scale.x*_xOffset, 0.0f, scale.z*_zOffset ) );
+	newPage->calculateErrors();
+	return newPage;
+}
+
+void Terrain::addLevelFourPage( int _numVertices, Vertex *_vertices, 
+	int _numIndices, unsigned short *_indices )
+{
+	assert( indices ); assert( vertices );
+	BufferInfo bi = buffers[current];	
+	if ( ( MAX_VERTICES < _numVertices+bi.numVertices ) || 
+		( MAX_INDICES < _numIndices+bi.numIndices+2 ) ) {
+		//So, we need the next vb and ib. Lets put the old into vram...
+		glBindBufferARB( GL_ARRAY_BUFFER_ARB, bi.vbIdentifier );
+		glBufferDataARB( GL_ARRAY_BUFFER_ARB, MAX_VERTICES*sizeof( Vertex ), 
+			vertices, GL_DYNAMIC_DRAW_ARB );
+		glBindBufferARB( GL_ELEMENT_ARRAY_BUFFER_ARB, bi.ibIdentifier );
+		glBufferDataARB( GL_ELEMENT_ARRAY_BUFFER_ARB, MAX_INDICES*sizeof( short ), 
+			indices, GL_DYNAMIC_DRAW_ARB );
+		BufferInfo newInfo;
+		broker->acquire( newInfo.vbIdentifier, newInfo.ibIdentifier );			
+		current++;	
+		buffers.push_back( newInfo );	
+		bi = newInfo;
+	}
+	//For the vertex data, a simple copy operation is sufficient...
+	memcpy( &vertices[bi.numVertices], _vertices, 
+		_numVertices*sizeof( Vertex ) );
+	//The indices need to be updated with an offset :(
+	unsigned short *dst= &indices[bi.numIndices];
+	unsigned short offset = bi.numVertices;
+	unsigned short *src= _indices;
+	unsigned short *end= src+_numIndices;
+	bi.numVertices+=_numVertices;		
+	if ( bi.numIndices ) {
+		dst[0] = *(dst-1);
+		dst[1] = *src+offset;
+		dst+=2; bi.numIndices+=2;
+	}
+	while ( src < end ) {
+		*dst= *src+offset;
+		dst++;
+		src++;
+	}
+	bi.numIndices+=_numIndices;
+	buffers[current] = bi;
+}
+
+void Terrain::determineVisiblePages( pTerrainQuad _node )
+{
+	switch( _node->cull() ) {
+		case Frustum::INTERSECT:
+			if ( !_node->isChildless() ) {
+				pTerrainQuad *children = _node->getChildren();
+				for ( int i = 0; i < 4; ++i, ++children )
+					determineVisiblePages( *children );
+			}
+			else {
+				showPages( _node->getXOffset(), 
+						   _node->getZOffset(), 1, 1 );
+			}
+			break;
+		case Frustum::INSIDE:
+			showPages( _node->getXOffset(), 
+					   _node->getZOffset(), 
+					   _node->getWidth() , 
+					   _node->getHeight() );
+			break;
+		case Frustum::OUTSIDE:
+			break;
+	}
+}
+
+void Terrain::tick( float _dt )
+{
+	for ( unsigned int i = 0; i < buffers.size(); ++i )
+		broker->release( buffers[i].vbIdentifier, buffers[i].ibIdentifier );
+	buffers.clear();	
+	pTerrainPage page = NULL;
+	//Extract the frustum planes out of the modelview matrix.
+	frustum->extractPlanes();	
+	// Lets see which pages are visible.
+	determineVisiblePages( root );
+	int wantedLeft, wantedRight, wantedBottom, wantedTop, minLOD;
+	pTerrainPage neighbor = NULL;
+	page = activePages;
+	bool dirty;
+	current = 0;
+	BufferInfo bi;
+	broker->acquire( bi.vbIdentifier, bi.ibIdentifier );
+	buffers.push_back( bi );
+	int dirtyRounds = 0;
+	do {
+		dirtyRounds++;
+		dirty = false;
+		page = activePages;
+		while ( page ) {
+			if ( !page->isActive() ) {
+				pTerrainPage tmp = page;
+				page = tmp->getNext();
+				tmp->setVisibility( false );
+				continue;
+			}
+			wantedLeft = wantedRight = wantedBottom = wantedTop = page->getWantedLOD();
+			if ( ( neighbor = page->getLeft() ) && ( neighbor->isActive() ) ) 
+				wantedLeft = neighbor->getWantedLOD();
+			if ( ( neighbor = page->getRight() ) && ( neighbor->isActive() ) ) 
+				wantedRight = neighbor->getWantedLOD();
+			if ( ( neighbor = page->getTop() ) && ( neighbor->isActive() ) ) 
+				wantedTop = neighbor->getWantedLOD();
+			if ( ( neighbor = page->getBottom() ) && ( neighbor->isActive() ) ) 
+				wantedBottom = neighbor->getWantedLOD();			
+		
+			minLOD = std::min( std::min( wantedBottom, wantedTop ), 
+				std::min( wantedLeft, wantedRight ) );	
+			if ( minLOD < page->getWantedLOD()-1 ) {
+				page->setWantedLOD( minLOD+1 );
+				dirty = true;
+			}	
+			page = page->getNext();
+		}
+	} while ( dirty );
+	
+	page = activePages;
+	while ( page ) {
+		assert( page->isActive() );
+		page->updateTesselation();
+		page = page->getNext();
+	}
+	//If there is some data in the buffer, we need to upload the data
+	//into the vram...
+	if ( buffers[current].numIndices != 0 ) {
+		BufferInfo bi = buffers[current];	
+		glBindBufferARB( GL_ARRAY_BUFFER_ARB, bi.vbIdentifier );
+		glBufferDataARB( GL_ARRAY_BUFFER_ARB, MAX_VERTICES*sizeof( Vertex ), 
+			vertices, GL_DYNAMIC_DRAW_ARB );
+		glBindBufferARB( GL_ELEMENT_ARRAY_BUFFER_ARB, bi.ibIdentifier );
+		glBufferDataARB( GL_ELEMENT_ARRAY_BUFFER_ARB, MAX_INDICES*sizeof( short ), 
+			indices, GL_DYNAMIC_DRAW_ARB );
+	}	
+}
+
+void Terrain::draw( )
+{
+	pTerrainPage page = NULL;
+	glGetError();
+	/*pTerrainPage page = NULL;
+	frustum->extractPlanes();*/
+	Plane far = frustum->getPlane( Frustum::FAR );
+	//Due to some reason, the OpenGL implementors chose the plane equation
+	//to an array of doubles. So we will make them happy.
+	double farPlane[] = { far.n.x, far.n.y, far.n.z, far.k };
+	glEnable( GL_CLIP_PLANE0 );
+	glClipPlane( GL_CLIP_PLANE0, farPlane );
+	glPushAttrib( GL_ALL_ATTRIB_BITS );
+	glPushClientAttrib( GL_CLIENT_VERTEX_ARRAY_BIT );
+	/*
+	 * Enable texture and vertex arrays for the first and the second texture
+	 * units and disable the normal arrays.
+	 */
+	glClientActiveTextureARB( GL_TEXTURE0_ARB );	
+		glEnableClientState( GL_VERTEX_ARRAY );
+		glEnableClientState( GL_TEXTURE_COORD_ARRAY ); 
+		glDisableClientState( GL_NORMAL_ARRAY );
+				
+	glClientActiveTextureARB( GL_TEXTURE1_ARB );	
+		glEnableClientState( GL_VERTEX_ARRAY );
+		glEnableClientState( GL_TEXTURE_COORD_ARRAY );
+		glDisableClientState( GL_NORMAL_ARRAY ); 
+	glDisable( GL_CULL_FACE );
+	glDisable( GL_LIGHTING );
+	glColor3f( 1.0f, 1.0f, 1.0f );
+	//glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
+	cullCount = 0;
+	glEnable( GL_BLEND );
+	glDepthFunc( GL_LEQUAL );
+	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
+	for ( unsigned int i = 0; i < layers.size(); ++i ) {
+		LayerInfo* layer= layers[i];
+		page = activePages;	
+				
+		glActiveTextureARB( GL_TEXTURE1_ARB );
+		glClientActiveTextureARB( GL_TEXTURE1_ARB );
+		if ( layer->detail ) {
+			//glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND );
+			glEnable( GL_TEXTURE_2D );
+			glBindTexture( GL_TEXTURE_2D, layer->detail->getTexture() );
+			glMatrixMode( GL_TEXTURE );
+			glLoadIdentity();
+			glScalef( layer->repeatX, layer->repeatZ, 1.0f );
+		}	
+		else {
+			glDisable( GL_TEXTURE_2D );
+		}
+		glEnable( GL_CULL_FACE );
+		glCullFace( GL_BACK );
+		glClientActiveTextureARB( GL_TEXTURE0_ARB );
+		glActiveTextureARB( GL_TEXTURE0_ARB );
+		glEnable( GL_TEXTURE_2D );
+		if ( layer->alpha ) {
+			//glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND );			
+			glBindTexture( GL_TEXTURE_2D, layer->alpha->getTexture() );
+		}
+		else {
+		
+			glBindTexture( GL_TEXTURE_2D, lightmap->getTexture() );			
+		}
+		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );				
+		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
+		
+		for ( unsigned j = 0; j < buffers.size(); ++j ) {
+			BufferInfo bi = buffers[j];
+			glBindBufferARB( GL_ARRAY_BUFFER_ARB, bi.vbIdentifier );
+			glClientActiveTextureARB( GL_TEXTURE0_ARB );
+			glInterleavedArrays( GL_T2F_V3F, 0, NULL );
+
+			glClientActiveTextureARB( GL_TEXTURE1_ARB );
+			glInterleavedArrays( GL_T2F_V3F, 0, NULL );
+
+			glBindBufferARB( GL_ELEMENT_ARRAY_BUFFER_ARB, 
+				bi.ibIdentifier );	
+
+			glDrawElements( GL_TRIANGLE_STRIP, bi.numIndices, 
+							GL_UNSIGNED_SHORT, NULL );
+		}
+		while ( page ) {
+			if ( page->hasMaterial( i ) )
+				page->draw();
+			page = page->getNext();
+		}
+	}
+	glClientActiveTextureARB( GL_TEXTURE1_ARB );	
+	glActiveTextureARB( GL_TEXTURE1_ARB );
+	glDisable( GL_TEXTURE_2D );
+	glActiveTextureARB( GL_TEXTURE0_ARB );
+	glEnable( GL_LIGHTING );
+	glMatrixMode( GL_TEXTURE );
+	glLoadIdentity();
+	glPopAttrib();
+	glPopClientAttrib();
+	glCullFace( GL_FRONT );
+	glDisable( GL_CLIP_PLANE0 );
+}
+
+inline Uint8 getAlpha( const SDL_Surface *_s, int _x, int _y )
+{
+    int bpp = _s->format->BytesPerPixel;
+    Uint8 *p = (Uint8 *)_s->pixels + _y*_s->pitch + _x * bpp;
+	Uint32 pixel = 0;
+    switch( bpp ) {
+    case 1:
+        pixel = *p;
+		break;
+    case 2:
+		if ( SDL_BYTEORDER == SDL_BIG_ENDIAN )
+			pixel = p[0] << 8 | p[1]; 
+		else
+        	pixel = *(Uint16 *)p;
+		break;
+    case 3:
+        if( SDL_BYTEORDER == SDL_BIG_ENDIAN )
+            pixel = p[0] << 16 | p[1] << 8 | p[2];
+        else
+            pixel = p[0] | p[1] << 8 | p[2] << 16;
+		break;
+    case 4:
+        pixel = *(Uint32 *)p;
+		break;
+    default:
+        return 255; /* shouldn't happen, but avoids warnings */
+    }
+	Uint8 r,g,b,a;
+	SDL_GetRGBA( pixel, _s->format, &r, &g, &b, &a );
+	return a;
+}
+
+void Terrain::determineLayerVisibility( int _layer )
+{
+	LayerInfo * layer = layers[_layer];
+	if ( !layer->alpha ) {
+		int numPages = pagesX*pagesZ;
+		for ( int i = 0; i < numPages; ++i )
+			pages[i]->setLayerVisibility( _layer, LV_FULL );
+			
+		return;
+	}
+	SDL_Surface *alpha = const_cast<SDL_Surface*>( layer->alpha->getStoredImage() );	
+	SDL_LockSurface( alpha );
+	float du = ( (float)alpha->w)/pagesX;
+	float dv = ( (float)alpha->h)/pagesZ;
+	float u = 0.0f, v = 0.0f;
+	for ( int pageX = 0; pageX < pagesX; ++pageX ) {
+		v = 0.0f;
+		for ( int pageZ = 0; pageZ < pagesZ; ++pageZ ) {
+			bool full = true; bool has = false;
+			for ( int x = 0; x < (int)PAGE_SIZE; ++x ) {
+				for ( int z = 0; z < (int)PAGE_SIZE; ++z ) {
+					Uint8 a = getAlpha( alpha, (int)u, (int)v );
+					if ( a ) 
+						has = true;
+					if ( a < 255 )
+						full = false;
+				}
+			}
+			LayerVisibility lv;
+			if ( has ) {
+				if ( full )
+					lv = LV_FULL;
+				else
+					lv = LV_PARTIAL;
+			}
+			else {
+				lv = LV_NO;
+			}
+			getPage( pageX, pageZ )->setLayerVisibility( _layer, lv );
+			v+= dv;
+		}
+		u+= du;
+	}
+	SDL_UnlockSurface( alpha );
+}
+
+void Terrain::getAltitude( Vector& _alt, Vector& _normal )
+{
+	float xScaled = _alt.x / scale.x, zScaled = _alt.z / scale.z;
+	//The offset on the map
+	int xOff =  (int)xScaled, zOff = (int)zScaled;
+	//The interpolation values.
+	float u = xScaled-xOff, v = zScaled-zOff;
+	
+	float dX = scale.x / ( pageSize-1 );
+	float dZ = scale.z / ( pageSize-1 );
+	
+	//If u is bigger than v, we are on the lower triangle...
+	if ( u > v ) {
+		
+		float alt[] = {
+			getAltitude( xOff+0, zOff+0 )*scale.y,
+			getAltitude( xOff+1, zOff+0 )*scale.y,
+			getAltitude( xOff+1, zOff+1 )*scale.y };
+		_alt.y = (1.0f-u-v)*alt[0]+u*alt[1]+v*alt[2];
+		
+		//Since we know about the directions of some x and z-coordinates, 
+		//not the whole cross products needs to be calculated. Grab yourself
+		//pen and paper :)
+		_normal.x =  dZ*( alt[0] - alt[1] );				
+		_normal.y =  dZ*dX;
+		_normal.z = -dX*( alt[2] - alt[1] );
+	}
+	else {
+		float alt[] = {
+			getAltitude( xOff+0, zOff+0 )*scale.y,
+			getAltitude( xOff+0, zOff+1 )*scale.y,
+			getAltitude( xOff+1, zOff+1 )*scale.y };			
+		_alt.y = (1.0f-u-v)*alt[0]+v*alt[1]+u*alt[2];
+		//Since we know about the directions of some x and z-coordinates, 
+		//not the whole cross products needs to be calculated. Grab yourself
+		//pen and paper :)
+		_normal.x = -dZ*( alt[2] - alt[1] );				
+		_normal.y =  dZ*dX;
+		_normal.z =  dX*( alt[0] - alt[1] );
+	}
+}
+
+void Terrain::showPages( int _x0, int _z0, int _width, int _height )
+{
+	for ( int x = 0; x < _width; ++x ) {
+		for ( int z = 0; z < _height; ++z ) {
+			pTerrainPage page = getPage( _x0+x, _z0+z );
+			page->setVisibility( true );			
+			page->chooseLOD();
+
+		}
+	}
+}
Index: branches/terrain/src/lib/graphics/importer/terrain/terrain.h
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/terrain.h	(revision 9414)
+++ branches/terrain/src/lib/graphics/importer/terrain/terrain.h	(revision 9414)
@@ -0,0 +1,233 @@
+/*
+	orxonox - the future of 3D-vertical-scrollers
+ 
+	Copyright (C) 2006 orx
+ 
+	This program is free software; you can redistribute it and/or modify
+	it under the terms of the GNU General Public License as published by
+	the Free Software Foundation; either version 2, or (at your option)
+	any later version.
+ 
+	### File Specific:
+	main programmer: Marco Biasini
+
+ */
+
+#ifndef _TERRAIN_H
+#define _TERRAIN_H
+
+#define USE_VBO
+#ifdef USE_VBO
+#include "buffer_broker.h"
+#endif
+
+#include "vector.h"
+#include "terrain_page.h"
+#include "terrain_quad.h"
+#include <cstdlib>
+#include <string>
+#include <vector>
+#include "texture.h"
+#include "frustum.h"
+
+class Texture;
+class Terrain;
+typedef Terrain *pTerrain;
+	
+class Terrain {
+	public:
+		const static unsigned int PAGE_SIZE 		= 17;
+		const static unsigned int MAX_VERTICES 		= PAGE_SIZE*PAGE_SIZE;
+		const static unsigned int MAX_INDICES		= 2*( PAGE_SIZE*PAGE_SIZE + PAGE_SIZE -2 );
+		/**
+		 * The amount of geometry rendered is largely depending on this constant. So chose a
+		 * reasonable value...
+		 */
+		inline float getDetail() { return 0.02f; }
+
+	
+		inline bool debug()
+		{
+			return false;
+		}
+		
+		inline pTerrainPage getActiveList() { return activePages; }
+
+	
+		inline void setCameraPosition( const Vector& _cameraPosition ) 
+		{ 
+			cameraPosition = _cameraPosition; 
+		}
+		
+		inline const Vector& getCameraPosition() const
+		{
+			return cameraPosition;
+		}
+	
+		void getAltitude( Vector& _alt, Vector& _normal );
+		
+		inline void setLightmap( Texture *_lightmap )
+		{
+			lightmap = _lightmap;
+		}
+		//What a bad name: Need to rename that :(
+		void addLevelFourPage( int _numVertices, Vertex *_vertices, 
+			int _numIndices, unsigned short *_indices );
+		void showPages( int _x0, int _z0, int _width, int _height );
+					
+		/**
+		 * Create a new terrain.
+		 */
+		Terrain( )
+		{ 
+			pageSize = 17;
+			pagesX = pagesZ = 0;
+			lightmap = NULL;
+			heightmapSource = "";
+			root = NULL;
+			current = 0;
+			activePages = NULL;
+			scale  = Vector( 1.0f, 3.0f, 1.0f );
+			frustum = new Frustum();
+			activatedCount = deactivatedCount = 0;
+			vertices = new Vertex[MAX_VERTICES];
+			indices = new unsigned short[MAX_INDICES];
+#ifdef USE_VBO
+			broker = new BufferBroker( 300, MAX_VERTICES*sizeof( Vertex ), 
+				MAX_INDICES*sizeof( short ) );
+#endif			
+		}
+		
+		~Terrain( ) 
+		{
+			//The pages are deleted through the SAVE_DELETE( root ) call.
+			SAVE_DELETE_ARRAY( pages );
+			SAVE_DELETE_ARRAY( vertices );
+			SAVE_DELETE_ARRAY( indices );
+			SAVE_DELETE( lightmap );
+			SAVE_DELETE( root );
+#ifdef USE_VBO
+			SAVE_DELETE( broker );
+#endif			
+		}
+		/**
+		 * Draws the terrain.
+		 */
+		void draw( );
+
+		void setPageSize( const Vector& _page ) { }
+		
+		void build();
+		void tick( float _dt );
+		inline void setActiveList( pTerrainPage _page )
+		{
+			activePages = _page;
+		}
+		inline pFrustum getViewingFrustum()
+		{
+			return frustum;
+		}
+		
+		/**
+		 * Returns the normalized ( range from [0..1] ) altitude from the heightmap for the given 
+		 * coordinates.
+		 */
+		inline float getAltitude( int _x, int _z ) const;
+		
+		inline void addMaterialLayer( LayerInfo *_layer )
+		{ layers.push_back( _layer ); }
+		
+		inline void setHeightmap( const std::string &_heightmap ) 
+		{ 
+			heightmapSource = _heightmap; 
+		}
+		
+		inline void setPageSize( int _pageSize )
+		{
+			pageSize = _pageSize;
+		}
+		
+		inline const Vector getScale() const { return scale; }
+		
+		inline int getPageSize() const 
+		{
+			return pageSize;
+		}
+		
+		inline void getCoord( int _x, int _z, TexCoord& _coord) const
+		{
+			_coord.u = ( ( float )_x )/( heightfield.width-1 );
+			_coord.v = ( ( float )_z )/( heightfield.height-1 );			
+		}
+		
+		inline void setScale( const Vector& _scale )
+		{ scale = _scale; }
+#ifdef USE_VBO
+		inline pBufferBroker getBufferBroker() { return broker; }
+#endif		
+		inline TerrainPage *getPage( int _x, int _z )
+		{
+			return pages[pagesX*_z+_x];
+		}
+	protected:
+			
+		/**
+		 * convenience method to create a new terrain page at position offset
+		 * p = ( _xOffset, _zOffset ). 
+		 */
+		pTerrainPage createPage( int _xOffset, int _zOffset ) const;				
+		
+		/**
+		 * Creates the quad tree structure for fast culling of the terrain pages.
+		 */		
+		pTerrainQuad createQuadTree( int _x0, int _z0, 
+			int _x1, int _z1, int _depth = 0 );
+		
+		/**
+		 * Walks the quad tree to determine which pages are visible, e.g. are in the viewing
+		 * frustum of the camera.
+		 */
+		void determineVisiblePages( pTerrainQuad _node );			
+		void determineLayerVisibility( int _layer );			
+		
+#ifdef USE_VBO
+		pBufferBroker				broker;
+#endif
+		pTerrainQuad				root;		// The quad-tree root node.
+		pTerrainPage				*pages;		// the references to all pages
+		std::string					heightmapSource;
+		Texture						*lightmap;
+		Heightfield					heightfield;
+		Vector						scale;
+		int 						pagesX, 
+									pagesZ;
+		int							pageSize;	
+		int							cullCount;
+		
+		int							activatedCount, 
+									deactivatedCount; // For debugging and statistics
+								
+		//The next five members are for the level 4 pages.						
+		Vertex						*vertices;						
+		unsigned short				*indices;
+		int							current;
+									
+		std::vector<BufferInfo>		buffers;			
+			
+		Vector						cameraPosition;
+		pFrustum					frustum;
+		pTerrainPage				activePages;
+		std::vector<LayerInfo*>		layers;
+};
+
+inline float Terrain::getAltitude( int _x, int _z ) const
+{
+	assert( heightfield.data );
+	if ( _x < 0 || _x >= heightfield.width || _z < 0 || _z >= heightfield.height ) {
+		return 0.0f;
+		printf( "outside!\n" );
+	}	
+	return heightfield.data[heightfield.pitch*_z+_x]/255.0f;	
+}
+
+#endif
